#ifndef __ARBOLBINARIOORDENADO_H__
#define __ARBOLBINARIOORDENADO_H__

#include "functornodo.h"
#include "espejo.h"

class NodoBinario;

//! Clase ArbolBinarioOrdenado implementa un rbol binario ordenado.

/*!
    Esta clase implementa un rbol binario ordenado con
    informacin entera.
 */
class ArbolBinarioOrdenado {
    public:
        ArbolBinarioOrdenado( );
        ~ArbolBinarioOrdenado( );

        NodoBinario *raiz( void );
        bool vacio( void );

        bool inserta( int info );
        void borrarNodo( NodoBinario *n );

        int alturaNodo( NodoBinario *n );
        int profundidadNodo( NodoBinario *n );
//
	bool buscarNodo(int valor);
	int hermanoNodo( NodoBinario *n);
	int tioNodo( NodoBinario *n);
	void sobrinosNodo ( NodoBinario *n, int &sobIzquierdo, int &sobDerecho);
	void primosNodo ( NodoBinario *n, int &priIzquierdo, int &priDerecho);
//
        void recorridoPrefijo( FunctorNodo *f );
        void recorridoInfijo( FunctorNodo *f );
        void recorridoPostfijo( FunctorNodo *f );
// 	
	void especularArbol( void );

    private:
        void raiz( NodoBinario *r );

        //! Raiz del rbol.

        /*!
            Puntero a la raiz del rbol.
         */
        NodoBinario *_raiz;
};

#endif
