#ifndef __FUNCTORNODO_H__
#define __FUNCTORNODO_H__

class NodoBinario;


//! Operaciones a realizar al recorrer el rbol

/*!
    Esta clase permite separar el hecho de recorrer el rbol
    (implementado en ArbolBinarioOrdenado::recorridoPrefijo,
    ArbolBinarioOrdenado::recorridoInfijo y
    ArbolBinarioOrdenado::recorridoPostfijo) de el realizar
    alguna operacin mientras se recorre.

    Un ejemplo de uso se encuentra en la clase InsertarLista.
 */
class FunctorNodo {
    public:
        FunctorNodo() {};
        virtual ~FunctorNodo() {};

        //! Aplica la operacin a un nodo

        /*!
            Este es el mtodo a sobrecargar para aplicar una
            operacin a cada nodo que se visita.
         */
        virtual void aplicar( NodoBinario *n )=0;
};

#endif
