#ifndef __VISORARBOL_H__
#define __VISORARBOL_H__

#include <qscrollview.h>
#include <qpoint.h>

class ArbolBinarioOrdenado;
class NodoBinario;
class OperacionDibujo;

class VisorArbol:public QScrollView {
    Q_OBJECT

    public:
        VisorArbol ( ArbolBinarioOrdenado *abo, QWidget * parent = 0,
            const char * name = 0, WFlags f = 0 );
        virtual ~VisorArbol();

    signals:
        //! Se ha seleccionado un nodo

        /*!
            El usuario ha seleccionado un nodo en la vista del rbol.

            \param n Nodo seleccionado.
         */
        void nodoSeleccionado( NodoBinario *n );

    public slots:
        void arbolModificado( ArbolBinarioOrdenado *abo );

    protected:
        virtual void drawContents ( QPainter * p, int clipx,
            int clipy, int clipw, int cliph );
        virtual void contentsMousePressEvent ( QMouseEvent * );

    private:
        //! rbol a representar
        ArbolBinarioOrdenado *_arbol;

        //! Nodo seleccionado actualmente
        NodoBinario *_nodoSeleccionado;

        //! Ancho en pixels de un nodo
        static const int _anchuraNodo=50;

        //! Alto en pixel de un nodo
        static const int _alturaNodo=50;

        //! Espacio vertical mnimo entre nodos
        static const int _espacioVertical=10;

        //! Espacio horizontal mnimo entre nodos
        static const int _espacioHorizontal=10;

        QRect recorre(NodoBinario *nodo, int prof, int &xIni,
            OperacionDibujo *op );

};

#endif
